stages:
    - build
    - test
    - build_image
    - deploy
    
build_app:
    stage: build
#    image: maven:3-openjdk-8
    tags:
        - shell_app
    script:
        - echo "build"
#        - mvn --version 
#        - mvn package
    artifacts:
        paths:
            - target/
        expire_in: 30 days

test_app:
    stage: test
    tags:
        - shell_app
#    image: maven:3-openjdk-8
    script:
        - echo "test"
 #       - mvn --version
    #    - mvn test

build_image_app:
    stage: build_image
    tags:
        - shell_app
    before_script:
        - docker login -u $DOCKER_USERNAME -p $DOCKER_PASSWORD
    script:
        - docker build -t $IMAGE_NAME_TAG:$IMAGE_TAG .
        - docker push $IMAGE_NAME_TAG:$IMAGE_TAG

deploy_app:
    stage: deploy
    before_script:
        - eval $(ssh-agent -s)
        - chmod 400 "$SSH_KEY"
        - ssh-add "$SSH_KEY"
        - mkdir -p ~/.ssh
        - chmod 700 ~/.ssh
    tags:
        - shell_app
    script:
        - ssh -o StrictHostKeyChecking=no -i $SSH_KEY cloud_user@34.245.98.25 
        - echo "success"

